<template>
  <div class="m-5 content-grid content-grid--subpage content-grid--subpage-table">
    <!--<Breadcrumbs :title="t(`routes.cours.children.cours.consult.name`)" />-->
    <div style="margin-top:60px" class="content-grid__header">
      <h1 class="back-link-title">{{ t(`routes.cours.children.cours.consult.name`) }}</h1>
      <div class="content-grid__filters">
        <SearchInput v-model="searchValue"/>
      </div>
    </div>
    <Card>
      <DataTable
        :headers="coursHeader"
        :items="tableCours"
        :search-value="searchValue"
        @delete="deleteCours"
      />
    </Card>
  </div>
</template>
<script lang="ts" setup>
import { useI18n } from "vue3-i18n";
import { computed, onMounted, ref } from "vue";
import { useCoursService, useGrilleService } from "@/inversify.config";
import { notifyError, notifySuccess } from "@/notify";
import Card from "@/components/layout/Card.vue";
import Breadcrumbs from "@/components/layout/Breadcrumbs.vue";
import DataTable from "@/components/layout/DataTable.vue";
import { Cours } from "@/types/entities/cours";
import SearchInput from "@/components/layout/SearchInput.vue";
    import { Grille } from "../../types/entities/creation-grille/Grille";
    import { useMemberService } from "@/inversify.config";
    import { useMemberStore } from "@/stores/memberStore";
/*import { currentUser } from "@/types/entities/cours";*/

const { t } = useI18n();
const allCours = ref<Cours[]>([]);
const coursService = useCoursService();
const searchValue = ref("");
    const memberService = useMemberService();
const tableCours = computed(() => {
  return allCours.value
    .map((x: Cours) => {
      return {
        id: x.id,
        code: x.code,
        nomCours: x.nomCours,
        actions: {
          update: {
            path: `/fr/cours/${x.id}/modifier`,
            params: { id: x.id },
          },
          delete: true,
          view: {
            path: `/fr/cours/${x.id}/details`,
            params: {
              id: x.id,
            },
          },
        },
      };
    })
    .sort((a: any, b: any) => {
      if (a.name < b.name) {
        return -1;
      }
      if (a.name > b.name) {
        return 1;
      }
      return 0;
    }) as unknown as Cours[];
});
onMounted(async () => {
    await loeadAllCours();
});

    async function loeadAllCours() {
        var members = await memberService.getAllMembers();
        var userConncte = await memberService.getCurrentMember();
        const member = await members.find((x) => x.email === userConncte?.email);
        if (member != null && member.id != null) {
            let cours = await coursService.getAllCoursByMember(member?.id);

            if (cours && cours.length > 0) {
                allCours.value = cours;
            }
        }
      
 
}

async function deleteCours(cours: Cours) {
  if (cours.id == null) return;
  let confirmation = confirm(t("validation.cours.delete.confirmation"));
  if (!confirmation) return;
  let response = await coursService.deleteCours(cours.id);
  if (response.succeeded) {
    allCours.value = allCours.value.filter((x) => x.id !== cours.id);
    notifySuccess(t("validation.cours.delete.success"));
  } else {
    let errorMessages = response.getErrorMessages(
      "validation.cours.delete.confirmation",
      "validation.cours.delete.errorOccured"
    );
    notifyError(errorMessages[0]);
  }
}
const coursHeader = [
  {
    text: "Code",
    value: "code",
    sortable: true,
    width: 300,
  },
  {
    text: "Nom Cours",
    value: "nomCours",
    sortable: true,
    width: 150,
  },
  {
    text: "",
    value: "actions",
    width: 75,
  },
];
</script>
